/*
 * command.h - irx command class
 *
 * Copyright (C) 1998 Alan Penner        (apenner@andrew.cmu.edu)
 *                    Ryan de Jonckheere (rjd@andrew.cmu.edu)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 *
 */

#ifndef _CMD_H
#define _CMD_H
#include <iostream.h>
#include <string>
#include "nfa.h"
#include "winlist.h"

struct command;
struct nfa;

enum action_type { KEY_ACTION, SYSTEM_ACTION, EXEC_ACTION, BUTTON_ACTION };

void getwindows( winlist& windows, Display* disp, Window w);

struct command
{
  nfa* window_name;
  action_type type;
  
  string comm;

  command* next;

  command(action_type t, string k, nfa* w);
  void add_event( action_type t, string k, nfa* w);
  void do_event(winlist& windows, Display* disp); 
  void send( Window w , Display* disp, string k, action_type t );
};
      
#endif
