/*
 * utils.cc - irx utils
 *
 * Copyright (C) 1998 Alan Penner        (apenner@andrew.cmu.edu)
 *                    Ryan de Jonckheere (rjd@andrew.cmu.edu)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 *
 */

#include <fstream.h>
#include <string>

bool gettoken(ifstream& filein, string& buffer)
{
  char a;
  buffer="";
  bool quoted = false;
  int i = 0;

  while(filein)
    {
      a = filein.get();
      switch(a)
	{
	case '\n':
	case '\t':
	  if(i != 0)
	    {
	      return true;
	    }
	  else
	    break;  // start over
	case '\"':
	  if(quoted)
	    {
	      return true;
	    }
	  else
	    quoted = true;
	  break;
	case '#':
	  while(filein && (filein.get() != '\n'));
	  if(i != 0)
	    {
	      return true;
	    }
	  else
	    break; // start over
	case ' ':
	  if(!quoted)
	    {
	      if(i != 0)
		{
		  return true;
		}
	      else
		break;
	    }
	default:
	  buffer=buffer+a;
	  i++;
	}
    }
  return false;
}

void die(char* fault)
{
  //cout << fault << endl;
  exit(1);
}
