/*
 * winlist.cc - irx window list grabber
 *
 * Copyright (C) 1998 Alan Penner        (apenner@andrew.cmu.edu)
 *                    Ryan de Jonckheere (rjd@andrew.cmu.edu)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 *
 */

#include<iostream.h>
#include<string>
#include<X11/Xlib.h>
#include "winlist.h"
#include "nfa.h"

void winlist::print(Display* disp)
{
  char* window_name;
  
  for (winlist_node* tmp = head; tmp; tmp = tmp -> next)
    {
      if (XFetchName(disp, tmp -> w, &window_name))
	cout << window_name << endl;
    }
}

void winlist::insert(Window w)
{
  winlist_node* newwin = new winlist_node(w);
  newwin -> prev = NULL;
  newwin -> next = head;
  if (head)
    head -> prev = newwin;
  head = newwin;
}

void winlist::remove(Window w)
{
  for (winlist_node* tmp = head; tmp; tmp = tmp -> next)
    {
      if (tmp -> w == w)
	{
	  if (tmp -> next)
	    tmp -> next -> prev = tmp -> prev;
	  if (tmp -> prev)
	    tmp -> prev -> next = tmp -> next;
	  winlist_node* tmp1 = tmp;
	  tmp = tmp -> prev;
	  delete tmp1;
	}
    }
}

void winlist::kill()
{
  winlist_node* tmp1;
  for (winlist_node* tmp = head; tmp;)
    {
      tmp1 = tmp -> next;
      delete tmp;
      tmp = tmp1;
    }
  head = NULL;
}
      

bool winlist::inlist(Window w)
{
  for (winlist_node* tmp = head; tmp; tmp = tmp -> next)
    if (tmp -> w == w) return true;

  return false;
}

void getwindows(winlist &windows, Display* disp, Window w)
{
  Window dummy, *children;
  unsigned int nchildren;
  windows.insert( w );
  
  if (!XQueryTree(disp, w, &dummy, &dummy, &children, &nchildren))
    return;

  for (int i = 0; i < nchildren; i++)
    getwindows( windows, disp, children[i] );
}

string cppstring( char* s )
{
  string retval="";
  for (int i =0; i < strlen(s); i++)
    retval+=s[i];
  return retval;
}

