/*
 * winlist.h - irx window list grabber
 *
 * Copyright (C) 1998 Alan Penner        (apenner@andrew.cmu.edu)
 *                    Ryan de Jonckheere (rjd@andrew.cmu.edu)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 * 
 *
 */

#ifndef WINLIST_H
#define WINLIST_H

#include<iostream.h>
#include<X11/Xlib.h>

struct winlist;
struct winlist_node;

struct winlist
{
  winlist_node* head;

  winlist(): head(NULL) {};
  void insert(Window w);
  void remove(Window w);
  bool inlist(Window w);
  void print(Display* disp);
  void kill();
  
  ~winlist() { kill(); };
};

struct winlist_node
{
  Window w;
  winlist_node* next;
  winlist_node* prev;

  winlist_node(Window win): w(win), next(NULL), prev(NULL) {};
};

#endif
